Subject: Re: bug#7150: 23.2.50; Include patch for distinguishing between left and right Alt keys on OSX
From: Jan Djärv <[email-masked]>
To: Jakub Turski <[email-masked]>
Cc: [email-masked]
Date: Mon, 11 Oct 2010 21:23:46 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

I commited the same functionality in the emacs-23 branch.  The patch you refer 
to makes none mean something else for right alt (follow left alt) than it does 
for the left alt (pass to system).  This is inconsistent, so I kept none to 
mean pass to system, and made a new value, left, to mean follow the left alt key.

	Jan D.

Jakub Turski skrev 2010-10-02 17.41:
> It's not a bug per se, rather a feature request.
> Would it be possible to include this patch:
> http://lists.aquamacs.org/pipermail/aquamacs-devel/2009-November/003853.html
> in Gnu Emacs? It's only relevant for OSX, but makes life easier for
> anyone who wants to use Emacs under OSX and uses a keyboard layout that
> uses right Alt key as a modifier to input special characters. This is an
> Aquamacs patch, and Aquamacs allows this:
>
> ;; Make right Meta a system modifier.
> (setq ns-right-alternate-modifier nil)
>
> which results in left Alt being interpreted by Aquamacs as Meta, and
> right Alt being interpreted by operating system as keyboard
> modifier. This allows me to use Polish keyboard layout without resorting
> to unusual method of inputting Polish characters. It would be good if
> other users, especially those that don't want to use Aquamacs because of
> some of its modifications, can use this feature.
>
> I've tried to naively apply this patch to current 23.2 sources, but
> failed - apparently it has diverged too much by now. I don't think I
> have both skills and time needed to modify this patch, but it looks
> relatively simple, provided you know your way around Emacs source code.
>
> Is there a chance to port and include this feature?
>
> Thanks,
>
> KT.
>
> In GNU Emacs 23.2.50.2 (x86_64-apple-darwin10.4.0, NS apple-appkit-1038.32)
>   of 2010-10-02 on imacoob.nerv.local
> Windowing system distributor `Apple', version 10.3.1038
> configured using `configure  '--with-ns''
>
> Important settings:
>    value of $LC_ALL: nil
>    value of $LC_COLLATE: pl_PL.UTF-8
>    value of $LC_CTYPE: pl_PL.UTF-8
>    value of $LC_MESSAGES: C
>    value of $LC_MONETARY: en_IE.utf-8
>    value of $LC_NUMERIC: en_IE.utf-8
>    value of $LC_TIME: en_IE.utf-8
>    value of $LANG: en_IE.UTF-8
>    value of $XMODIFIERS: nil
>    locale-coding-system: utf-8-unix
>    default enable-multibyte-characters: t
>
> Major mode: Fundamental
>
> Minor modes in effect:
>    global-whitespace-mode: t
>    tooltip-mode: t
>    mouse-wheel-mode: t
>    menu-bar-mode: t
>    file-name-shadow-mode: t
>    global-font-lock-mode: t
>    auto-encryption-mode: t
>    auto-compression-mode: t
>    line-number-mode: t
>    transient-mark-mode: t
>
> Recent input:
> C-x 1 M-x r e p o r t - e m a<tab>  <return>
>
> Recent messages:
> For information about GNU Emacs and the GNU system, type C-h C-a.
>
> Load-path shadows:
> None found.
>
> Features:
> (shadow sort mail-extr message ecomplete rfc822 mml mml-sec
> password-cache mm-decode mm-bodies mm-encode mailcap mail-parse rfc2231
> rfc2047 rfc2045 qp ietf-drums mailabbrev nnheader gnus-util netrc
> time-date mm-util mail-prsvr gmm-utils wid-edit mailheader canlock sha1
> hex-util hashcash mail-utils emacsbug warnings disp-table whitespace
> tooltip ediff-hook vc-hooks lisp-float-type mwheel ns-win easymenu
> tool-bar dnd fontset image fringe lisp-mode register page menu-bar
> rfn-eshadow timer select scroll-bar mldrag mouse jit-lock font-lock
> syntax facemenu font-core frame cham georgian utf-8-lang misc-lang
> vietnamese tibetan thai tai-viet lao korean japanese hebrew greek
> romanian slovak czech european ethiopic indian cyrillic chinese
> case-table epa-hook jka-cmpr-hook help simple abbrev loaddefs button
> minibuffer faces cus-face files text-properties overlay md5 base64
> format env code-pages mule custom widget hashtable-print-readable
> backquote make-network-process ns multi-tty emacs)
>
>